#ifndef CEFFECTS_H
#define CEFFECTS_H

#include <SDL/SDL.h>
#include <SDL/SDL_gfxPrimitives.h>
#include <stdlib.h>
#include <time.h>
#include "functions.h"
#include "CWorldParts.h"




enum Effects {EfPixelRemove,EfHorizontalLine,EfVerticalLine,EfBlockRemove,EfAlpha,EfNone};

class CEffects
{
    private:
        Effects CurrentEffect;
        SDL_Surface *CurrentImage;
        int Steps;
        int MaxSteps;
        int X1,Y1,X2,Y2,NrOfLines,NrOfBlocks;
        int PixelRemoveNumPixels;
        int BlockWidth,BlockHeight;
        int AlphaInc;
        int AlphaValue;
        //float TotalSecs;
        void DoPixelRemove();
        void DoHorizontalLine();
        void DoVerticalLine();
        void DoBlockRemove();
        void DoAlpha();


    public:
        int StartX,StartY,EndX,EndY;
        bool Done;
        CEffects(SDL_Surface *Source,int X,int Y,int Width,int Height);
        void PixelRemove(int aMaxSteps,int AmountOfPixelsPerStep);
        void HorizontalLine(int aMaxSteps,int aNrOfLines,int aHeight);
        void VerticalLine(int aMaxSteps, int aNrOfLines,int aWidth);
        void BlockRemove(int aMaxSteps,int aNrOfBlocks,int aWidth, int aHeight);
        void Alpha(int aMaxSteps,int aAlphaInc);
        void DoEffect();
        void Draw(SDL_Surface *Dest);
        ~CEffects();

};

#endif
