#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fstream>
#include <dirent.h>
#include <unistd.h>
#include <SDL/SDL_keysym.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>
#include <SDL/SDL_gfxPrimitives.h>
#include <SDL/SDL_framerate.h>
#include <SDL/SDL_mixer.h>

#ifdef N810
    #include <SDL/SDL_syswm.h>
    #include <X11/Xutil.h>
#endif

#include "main.h"
#include "functions.h"
#include "CWorldParts.h"
#include "CBox.h"
#include "CEffects.h"



using namespace std;




void LoadGraphics()
{
	char FileName[PATH_MAX+FILENAME_MAX];
    SDL_Surface *Tmp;
    FILE *ColorFile;
    int R,G,B;


	if(IMGArrows1)
		SDL_FreeSurface(IMGArrows1);
	if(IMGArrows2)
		SDL_FreeSurface(IMGArrows2);
	if(IMGBackground)
		SDL_FreeSurface(IMGBackground);
    if(IMGLevelDone)
		SDL_FreeSurface(IMGLevelDone);
	if(IMGBlocks)
		SDL_FreeSurface(IMGBlocks);
    if(IMGFloor)
        SDL_FreeSurface(IMGFloor);
    if(IMGGameOver)
        SDL_FreeSurface(IMGGameOver);
    if(IMGLevelpackDone)
		SDL_FreeSurface(IMGLevelpackDone);
    if(IMGTitleScreen)
		SDL_FreeSurface(IMGTitleScreen);
    if(IMGGrid)
        SDL_FreeSurface(IMGGrid);
    if(IMGBackgroundLevelEditor)
		SDL_FreeSurface(IMGBackgroundLevelEditor);


    sprintf(FileName,"%sskins/%s/grid.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/grid.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGGrid= SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);
    SDL_SetColorKey(IMGGrid,SDL_SRCCOLORKEY | SDL_RLEACCEL,SDL_MapRGB(IMGGrid->format,255,0,255));


    sprintf(FileName,"%sskins/%s/gameover.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/gameover.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGGameOver= SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);

    sprintf(FileName,"%sskins/%s/titlescreen.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/titlescreen.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGTitleScreen= SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);


    sprintf(FileName,"%sskins/%s/arrows1.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/arrows1.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGArrows1= SDL_DisplayFormat(Tmp);
    SDL_SetColorKey(IMGArrows1,SDL_SRCCOLORKEY | SDL_RLEACCEL,SDL_MapRGB(IMGArrows1->format,255,0,255));
    SDL_FreeSurface(Tmp);

    sprintf(FileName,"%sskins/%s/arrows2.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/arrows2.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGArrows2= SDL_DisplayFormat(Tmp);
    SDL_SetColorKey(IMGArrows2,SDL_SRCCOLORKEY | SDL_RLEACCEL,SDL_MapRGB(IMGArrows2->format,255,0,255));
    SDL_FreeSurface(Tmp);

    sprintf(FileName,"%sskins/%s/leveldone.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/leveldone.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGLevelDone= SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);

    sprintf(FileName,"%sskins/%s/levelpackdone.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/levelpackdone.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGLevelpackDone= SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);


	sprintf(FileName,"%sskins/%s/background.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/background.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGBackground= SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);

    sprintf(FileName,"%sskins/%s/backgroundleveleditor.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/backgroundleveleditor.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGBackgroundLevelEditor= SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);


    sprintf(FileName,"%sskins/%s/floor.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/floor.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGFloor= SDL_DisplayFormat(Tmp);
    SDL_SetColorKey(IMGFloor,SDL_SRCCOLORKEY | SDL_RLEACCEL,SDL_MapRGB(IMGFloor->format,255,0,255));
    SDL_FreeSurface(Tmp);

    sprintf(FileName,"%sskins/%s/blocks.png",StartPath,SkinName);
    if (FileExists(FileName))
        Tmp = IMG_Load(FileName);
    else
    {
        sprintf(FileName,"%sgraphics/blocks.png",StartPath);
        Tmp = IMG_Load(FileName);
    }
    IMGBlocks= SDL_DisplayFormat(Tmp);
    SDL_SetColorKey(IMGBlocks,SDL_SRCCOLORKEY | SDL_RLEACCEL,SDL_MapRGB(IMGBlocks->format,255,0,255));
    SDL_FreeSurface(Tmp);


    sprintf(FileName,"%sskins/%s/color.txt",StartPath,SkinName);
    if (FileExists(FileName))
    {
        ColorFile = fopen(FileName,"r");
        fscanf(ColorFile,"TextColor_R=%d\nTextColor_G=%d\nTextColor_B=%d\n",&R,&G,&B);
        fclose(ColorFile);
        TextColor.r = R;
        TextColor.g = G;
        TextColor.b = B;
    }
    else
    {
        sprintf(FileName,"%sgraphics/color.txt",StartPath);
        ColorFile = fopen(FileName,"r");
        fscanf(ColorFile,"TextColor_R=%d\nTextColor_G=%d\nTextColor_B=%d\n",&R,&G,&B);
        fclose(ColorFile);
        TextColor.r = R;
        TextColor.g = G;
        TextColor.b = B;
    }
}


void UnLoadGraphics()
{
    if(IMGArrows1)
		SDL_FreeSurface(IMGArrows1);
	if(IMGArrows2)
		SDL_FreeSurface(IMGArrows2);
	if(IMGBackground)
		SDL_FreeSurface(IMGBackground);
    if(IMGLevelDone)
		SDL_FreeSurface(IMGLevelDone);
	if(IMGBlocks)
		SDL_FreeSurface(IMGBlocks);
    if(IMGFloor)
        SDL_FreeSurface(IMGFloor);
    if(IMGGameOver)
        SDL_FreeSurface(IMGGameOver);
    if(IMGLevelpackDone)
		SDL_FreeSurface(IMGLevelpackDone);
    if(IMGTitleScreen)
		SDL_FreeSurface(IMGTitleScreen);
    if(IMGGrid)
        SDL_FreeSurface(IMGGrid);
    if(IMGBackgroundLevelEditor)
		SDL_FreeSurface(IMGBackgroundLevelEditor);
}

void NextSkin()
{
    char Text[500];
    SDL_Color Color = {255,255,255,255};
    SDL_Rect Rect;
    Rect.w = SDLScreen->w;
    Rect.h = SDLScreen->h;
    Rect.x = 0;
    Rect.y = 0;
    if(InstalledSkinsCount > 0)
    {
        SelectedSkin++;
        if (SelectedSkin >=InstalledSkinsCount)
            SelectedSkin = -1;
        if(SelectedSkin == -1)
        {
            sprintf(SkinName,"%s","");
            sprintf(Text,"Please Wait Loading Skin:\nDefault Skin");
        }
        else
        {
            sprintf(SkinName,"%s",InstalledSkins[SelectedSkin]);
            sprintf(Text,"Please Wait Loading Skin:\n%s",SkinName);
        }
        boxRGBA(SDLScreen,0,0,799,100,255,255,255,200);
        boxRGBA(SDLScreen,2,2,798,98,0,0,0,200);
        WriteText(SDLScreen,BigFont,Text,strlen(Text),10,0,0,Color);
        SDL_Flip(SDLScreen);
        LoadGraphics();
    }
}


void SetVolume(const int VolumeIn)
{
	if (GlobalSoundEnabled)
	{
		Mix_Volume(0,VolumeIn);
		Mix_Volume(1,VolumeIn);
		Mix_VolumeMusic(2*(VolumeIn /3));
	}
}

void IncVolume()
{
	if (Volume < 128)
	{
		Volume += 8;
		SetVolume(Volume);
	}
}

void DecVolume()
{
	if (Volume > 0)
	{
		Volume-= 8;
		SetVolume(Volume);
	}
}

void LoadSettings()
{
	FILE *Fp;
	char FileName[PATH_MAX+FILENAME_MAX];
	sprintf(FileName,"%s/.puzznicsettings",getenv("HOME"));
	Fp = fopen(FileName,"rt");
	if (Fp)
	{
		fscanf(Fp,"Volume=%d\n",&Volume);
		fscanf(Fp,"Skin=%s\n",&SkinName);
		fclose(Fp);
	}
	else
	{
		Volume = 128;
	}
	SetVolume(Volume);
}

void SaveSettings()
{
	FILE *Fp;
	char FileName[PATH_MAX+FILENAME_MAX];
	sprintf(FileName,"%s/.puzznicsettings",getenv("HOME"));
	Fp = fopen(FileName,"wt");
	if (Fp)
	{
		fprintf(Fp,"Volume=%d\n",Volume);
		fprintf(Fp,"Skin=%s\n",SkinName);
		fclose(Fp);
#ifdef N810
		sync();
#endif
	}
}



void SearchForMusic()
{
	struct dirent *Entry;
	DIR *Directory;
	struct stat Stats;
	int Teller;
	char FileName[PATH_MAX+FILENAME_MAX];
	char Path[PATH_MAX];

    sprintf(FileName,"%smusic/title.mod",StartPath);
    Music[0] = Mix_LoadMUS(FileName);
	Teller=1;

	sprintf(Path,"%smusic",StartPath);
	Directory = opendir(Path);
	if (Directory)
	{
		Entry=readdir(Directory);
		while(Entry)
		{
			sprintf(FileName,"%smusic/%s",StartPath,Entry->d_name);
			stat(FileName,&Stats);
			if(!S_ISDIR(Stats.st_mode))
			{
				if(strncmp(".", Entry->d_name, 1) && (strcmp("title.mod",Entry->d_name) != 0) && (Teller< MaxMusicFiles))
				{
				//	printf("%s\n",Entry->d_name);
					if (GlobalSoundEnabled)
					{
						Music[Teller] = Mix_LoadMUS(FileName);
						Teller++;
					}
				}
			}
			Entry=readdir(Directory);
		}
		closedir(Directory);
	}
	MusicCount = Teller;
}

void SearchForSkins()
{
	struct dirent *Entry;
	DIR *Directory;
	struct stat Stats;
	int Teller=0;
	char FileName[PATH_MAX+FILENAME_MAX];
	char Path[PATH_MAX];
	sprintf(Path,"%sskins",StartPath);
	Directory = opendir(Path);
	if (Directory)
	{
		Entry=readdir(Directory);
		while(Entry)
		{
			sprintf(FileName,"%sskins/%s",StartPath,Entry->d_name);
			stat(FileName,&Stats);
			if(S_ISDIR(Stats.st_mode))
			{
				//printf("%s\n",Entry->d_name);
				if(strncmp(".", Entry->d_name, 1)  && (Teller< MaxSkins) && (strlen(Entry->d_name) < FILENAME_MAX-1))
				{
					sprintf(InstalledSkins[Teller],"%s",Entry->d_name);
					Teller++;
				}
			}
			Entry=readdir(Directory);
		}
		closedir(Directory);
	}
	InstalledSkinsCount = Teller;
	SelectedSkin=-1;
}

void SearchForLevelPacks()
{
	struct dirent *Entry;
	DIR *Directory;
	struct stat Stats;
	int Teller=0;
	char FileName[PATH_MAX + FILENAME_MAX];
	char Path[PATH_MAX];

    sprintf(InstalledLevelPacks[0] ,"levels.dat");
	Teller=1;
	sprintf(Path,"%slevels",StartPath);
	Directory = opendir(Path);
	if (Directory)
	{
		Entry=readdir(Directory);
		while(Entry)
		{
			sprintf(FileName,"%slevels/%s",StartPath,Entry->d_name);
			stat(FileName,&Stats);
			if(!S_ISDIR(Stats.st_mode))
			{
				//printf("%s\n",Entry->d_name);
				if(strncmp(".", Entry->d_name, 1)  && (Teller< MaxLevelPacks) && (strcmp("levels.dat",Entry->d_name) != 0))
				{
					sprintf(InstalledLevelPacks[Teller],"%s",Entry->d_name);
					Teller++;
				}
			}
			Entry=readdir(Directory);
		}
		closedir(Directory);
	}
	InstalledLevelPacksCount = Teller;
	SelectedLevelPack=0;
}



void UnloadMusic()
{
	int Teller;
	if (GlobalSoundEnabled)
	{
		Mix_HaltMusic();
		for (Teller=0;Teller < MusicCount;Teller++)
			if (Music[Teller])
				Mix_FreeMusic(Music[Teller]);
	}
}

void LoadSounds()
{
    char FileName[PATH_MAX+FILENAME_MAX];

	if (GlobalSoundEnabled)
	{
	    sprintf(FileName,"%ssound/destroy.wav",StartPath);
        Sounds[SND_Destroy] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/nomoves.wav",StartPath);
        Sounds[SND_NoMoves] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/win.wav",StartPath);
        Sounds[SND_Win] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/winexit.wav",StartPath);
        Sounds[SND_WinExit] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/directionmove.wav",StartPath);
        Sounds[SND_DirectionMove] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/gameover.wav",StartPath);
        Sounds[SND_GameOver] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/score.wav",StartPath);
        Sounds[SND_Score] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/leveleditorselect.wav",StartPath);
        Sounds[SND_LevelEditorSelect] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/select.wav",StartPath);
        Sounds[SND_Select] = Mix_LoadWAV(FileName);
        sprintf(FileName,"%ssound/error.wav",StartPath);
        Sounds[SND_Error] = Mix_LoadWAV(FileName);


	}
}


void UnloadSounds()
{
	int Teller;
	for (Teller=0;Teller<NrOfSounds;Teller++)
		if(Sounds[Teller])
			Mix_FreeChunk(Sounds[Teller]);
}


void RemoveBlocks(CWorldParts *aWorldParts)
{
    CBox* Box;
    int Teller;
    bool PlaySound=false;
    for (Teller=0;Teller<aWorldParts->ItemCount;Teller++)
    {
        Box = (CBox*) aWorldParts->Items[Teller];
        if(Box->Remove)
        {
            aWorldParts->Remove(Box->GetPlayFieldX(), Box->GetPlayFieldY());
            PlaySound = true;
            Teller--;
        }
    }
}

bool DeathBlocks(CWorldParts *aWorldParts)
{
    CBox* Box;
    int Teller;
    for (Teller=0;Teller<aWorldParts->ItemCount;Teller++)
    {
        Box = (CBox*) aWorldParts->Items[Teller];
        if(Box->Death || Box->Remove)
            return true;
    }
    return false;
}

void DrawFloor(CWorldParts *aWorldParts,SDL_Surface* Surface)
{
    int X,Y,Z;
    CWorldPart *Part;
    SDL_Rect DstRect;
    bool BlockLeft,BlockUp,BlockRight,BlockDown;
    for(Y=0;Y<NrOfRows;Y++)
    {
        for (X=0;X<NrOfCols;X++)
        {

            BlockDown = false;
            BlockUp = false;
            BlockLeft = false;
            BlockRight = false;
            for(Z=X;Z>=0;Z--)
            {
                Part = aWorldParts->GetItemFromPosPlayField(Z,Y);
                if(Part != NULL)
                {
                    if(Part->GetType() == 5)
                    {
                        BlockLeft = true;
                        break;
                    }
                }
            }

            for(Z=X;Z<NrOfCols;Z++)
            {
                Part = aWorldParts->GetItemFromPosPlayField(Z,Y);
                if(Part != NULL)
                {
                    if(Part->GetType() == 5)
                    {
                        BlockRight = true;
                        break;
                    }
                }
            }

            for(Z=Y;Z>=0;Z--)
            {
                Part = aWorldParts->GetItemFromPosPlayField(X,Z);
                if(Part != NULL)
                {
                    if(Part->GetType() == 5)
                    {
                        BlockUp = true;
                        break;
                    }
                }
            }

            for(Z=Y;Z<NrOfRows;Z++)
            {
                Part = aWorldParts->GetItemFromPosPlayField(X,Z);
                if(Part != NULL)
                {
                    if(Part->GetType() == 5)
                    {
                        BlockDown = true;
                        break;
                    }
                }
            }

            if(BlockDown && BlockLeft && BlockRight && BlockUp)
            {
                DstRect.w = TileWidth;
                DstRect.h = TileHeight;
                DstRect.x = (X*TileWidth) + Xoffset;
                DstRect.y = (Y*TileWidth) + Yoffset;
                SDL_BlitSurface(IMGFloor,NULL,Surface,&DstRect);
            }



        }


    }
}

int EraseBlocks(CWorldParts *aWorldParts,int X,int Y)
{
    CBox *Start,*Down,*Up,*Left,*Right;
    int Result = 0;

    Start = (CBox*) aWorldParts->GetItemFromPosPlayField(X,Y) ;
    if(Start != NULL)
    {
        Result +=1;
        if((Start->GetType() !=5) && (Start->GetType() !=4) && !Start->Death)
        {
            Left = (CBox*)aWorldParts->GetItemFromPosPlayField(X-1,Y);
            if((Left != NULL))
            if((Left->GetType() == Start->GetType()))
            {
                Result +=1;
                Left->Death = true;
                Start->Death = true;
                Result += EraseBlocks(WorldParts,X-2,Y);
            }

            Down = (CBox*)aWorldParts->GetItemFromPosPlayField(X,Y+1);
            if((Down != NULL))
            if(Down->GetType() == Start->GetType())
            {
                Result +=1;
                Down->Death = true;
                Start->Death = true;
                Result +=  EraseBlocks(WorldParts,X,Y+2);
            }

            Up = (CBox*)aWorldParts->GetItemFromPosPlayField(X,Y-1);
            if((Up != NULL))
            if(Up->GetType() == Start->GetType())
            {

                Result +=1;
                Up->Death = true;
                Start->Death = true;
                Result +=  EraseBlocks(WorldParts,X,Y-2);
            }


            Right =(CBox*) aWorldParts->GetItemFromPosPlayField(X+1,Y);
            if((Right != NULL))
            if(Right->GetType() == Start->GetType())
            {
                Result +=1;
                Right->Death = true;
                Start->Death = true;
                Result +=  EraseBlocks(WorldParts,X+2,Y);
            }

        }
    }
    return Result;
}

bool LevelWon(CWorldParts *aWorldParts)
{
    int Teller;
    for (Teller=0;Teller<WorldParts->ItemCount;Teller++)
    {
        if((aWorldParts->Items[Teller]->GetType() > 0) && (aWorldParts->Items[Teller]->GetType() < 4))
            return false;
    }
    return true;
}

bool NoMovesLeft(CWorldParts *aWorldParts)
{
    int Teller,NumBlock1=0,NumBlock2=0,NumBlock3=0;
    for(Teller=0;Teller<aWorldParts->ItemCount;Teller++)
    {
        if(aWorldParts->Items[Teller]->GetType() == 1)
            NumBlock1++;
        if(aWorldParts->Items[Teller]->GetType() == 2)
            NumBlock2++;
        if(aWorldParts->Items[Teller]->GetType() == 3)
            NumBlock3++;

    }
    return ((NumBlock1 == 1) || (NumBlock2 == 1) || (NumBlock3 ==1));

}

void DrawArrows(SDL_Surface *Surface)
{
    SDL_Rect SrcRect,DstRect;
    int Teller;

    for(Teller=0;Teller<4;Teller++)
    {
        SrcRect.x = 0;
        SrcRect.w = 80;
        SrcRect.h = 80;
        DstRect.w = 80;
        DstRect.h = 80;
        if(Teller != Movement)
        {
            SrcRect.y = Teller * 80;
            DstRect.x = DestRectsArrows[Teller].x;
            DstRect.y = DestRectsArrows[Teller].y;
            SDL_BlitSurface(IMGArrows1,&SrcRect,Surface,&DstRect);
        }
        else
            if(Movement != MNone)
            {
                SrcRect.y = Movement * 80;
                DstRect.x = DestRectsArrows[Movement].x;
                DstRect.y = DestRectsArrows[Movement].y;
                SDL_BlitSurface(IMGArrows2,&SrcRect,Surface,&DstRect);
            }

    }
}

int GetMouseSelection(int X,int Y)
{
    int Teller;


    for(Teller=0;Teller<4;Teller++)
    {
        if ((X > DestRectsArrows[Teller].x)  && (X < DestRectsArrows[Teller].x + DestRectsArrows[Teller].w) &&
            (Y > DestRectsArrows[Teller].y)  && (Y < DestRectsArrows[Teller].y + DestRectsArrows[Teller].h))
                return Teller;
    }
    return -1;

}

void StageClear()
{
    int FPS=0, FrameCounter=0, ScoreStatus = 0, RetryScore=0, ClearScore=0, MoveScore=0, TotalScore=0;
    Mix_PlayChannel(-1,Sounds[SND_Win],0);
    SDL_Event Event;
    Uint32 Time = 0;
    char Text[512];
    Movement = MNone;
    CEffects *Effect = new CEffects(SDLScreen,330,0,800-330-1,479);
    RetryScore=Retries*1000;
    ClearScore=((WorldParts->GetLevel() / 10) + 1)*1000;
    MoveScore=MaxMoves*500;
    TotalScore=RetryScore+ClearScore+MoveScore;
    srand((int) time(NULL));
    switch(rand() % 5)
    {
        case 3:
            Effect->VerticalLine(10,20,3);
            break;
        case 2:
            Effect->HorizontalLine(10,20,3);
            break;
        case 1:
            Effect->BlockRemove(10,2000,5,5);
            break;
        case 4:
            Effect->PixelRemove(10,25000);
            break;
        case 0:
            Effect->Alpha(5,50);
            break;
    }

    while (GameState == GSStageClear)
    {
        if(GlobalSoundEnabled)
            if (! Mix_PlayingMusic())
            {
                SelectedMusic =	rand()%(MusicCount);
                Mix_PlayMusic(Music[SelectedMusic],0);
                SetVolume(Volume);
            }

        SDL_BlitSurface(IMGLevelDone,NULL,SDLScreen,NULL);
        sprintf(Text,"Score: %d\nLevel Number: %d\nMoves Left: %d\nRetry: %d\n",Score,WorldParts->GetLevel(),MaxMoves,Retries);
        WriteText(SDLScreen,font,Text,strlen(Text),42,100,0,TextColor);
        sprintf(Text,"Clear Bonus:   %dx1000 = %4d\nRetry Bonus:   %dx1000 = %d\nMoves Bonus:  %dx500   = %d\n",(WorldParts->GetLevel() / 10) + 1,ClearScore,Retries,RetryScore,MaxMoves,MoveScore);
        WriteText(SDLScreen,font,Text,strlen(Text),380,130,5,TextColor);
        sprintf(Text,"Total Bonus: %d\n",TotalScore);
        WriteText(SDLScreen,BigFont,Text,strlen(Text),380,280,5,TextColor);
        sprintf(Text,"Score: %d\n",Score);
        WriteText(SDLScreen,BigFont,Text,strlen(Text),380,340,5,TextColor);
        DrawArrows(SDLScreen);
        Effect->DoEffect();
        Effect->Draw(SDLScreen);
        if(!Effect->Done)
            SDL_UpdateRect(SDLScreen,Effect->StartX,Effect->StartY,Effect->EndX - Effect->StartX,Effect->EndY - Effect->StartY);
        else
            SDL_Flip(SDLScreen);
        FrameCounter++;

        while (SDL_PollEvent(&Event))
        {

            if (Event.type == SDL_QUIT)
                GameState=GSQuit;

            if (Event.type == SDL_MOUSEBUTTONUP)
            {
                if((Event.button.x > 18) && (Event.button.x < 18+272) && (Event.button.y > 7) && (Event.button.y < 7 + 72))
                {
                    Mix_PlayChannel(-1,Sounds[SND_Select],0);
                    PreviousGameState = GameState;
                    GameState = GSTitleScreen;
                }
                else
                {
                    ScoreStatus++;
                    if(ScoreStatus ==3)
                    {

                        if(WorldParts->GetLevel() + 1 <= WorldParts->LevelCount)
                        {
                            WorldParts->IncLevel();
                            PreviousGameState = GameState;
                            GameState=GSGame;
                        }
                        else
                        {
                            PreviousGameState = GameState;
                            GameState = GSLevelpackDone;
                        }
                    }
                }
            }

            if ((Event.type == SDL_KEYDOWN))
            {
                switch(Event.key.keysym.sym)
                {
                    case SDLK_PLUS:
                        IncVolume();
                        break;

                    case SDLK_MINUS:
                        DecVolume();
                        break;

                    case SDLK_l:
                        NextSkin();
                        WorldParts->AssignImage(IMGBlocks);
                        break;

                    default:
                        ScoreStatus++;
                        if(ScoreStatus ==3)
                        {
                            if(WorldParts->GetLevel() + 1 <= WorldParts->LevelCount)
                            {
                                WorldParts->IncLevel();
                                PreviousGameState = GameState;
                                GameState=GSGame;
                            }
                            else
                            {
                                PreviousGameState = GameState;
                                GameState = GSLevelpackDone;
                            }
                        }


                        break;

                }
            }

        }
        if(ScoreStatus == 1)
        {
            if(TotalScore > 0)
            {
                Score+=100;
                TotalScore -=100;
                if(TotalScore % 300 == 0)
                    Mix_PlayChannel(-1,Sounds[SND_Score],0);
            }
            else
                ScoreStatus++;
        }

        if(ScoreStatus == 2)
        {
             Score+=TotalScore;
             TotalScore = 0;
        }
        if(Time + 1000 < SDL_GetTicks())
        {

            FPS = FrameCounter;
            FrameCounter =0;
            Time=SDL_GetTicks();
        }
        SDL_framerateDelay(&Fpsman);


    }
    Mix_PlayChannel(-1,Sounds[SND_WinExit],0);
    delete Effect;



//
//    else
//    {
//        Levelpack done
//    }

}


void LevelpackDone()
{
    SDL_Event Event;
    char Text[512];
    Uint32 Time = 0;
    int FPS=0,FrameCounter=0;
    Movement = MNone;
    CEffects *Effect = new CEffects(SDLScreen,300,0,800-300-1,479);
    srand((int) time(NULL));
    Effect->BlockRemove(10,2000,5,5);
    while (GameState == GSLevelpackDone)
    {
         if(GlobalSoundEnabled)
            if (! Mix_PlayingMusic())
            {
                SelectedMusic =	rand()%(MusicCount);
                Mix_PlayMusic(Music[SelectedMusic],0);
                SetVolume(Volume);
            }

        SDL_BlitSurface(IMGLevelpackDone,NULL,SDLScreen,NULL);
        sprintf(Text,"Score: %d\nLevel Number: %d\nMoves Left: %d\nRetry: %d\n",Score,WorldParts->GetLevel(),MaxMoves,Retries);
        WriteText(SDLScreen,font,Text,strlen(Text),42,100,0,TextColor);
        DrawArrows(SDLScreen);
        Effect->DoEffect();
        Effect->Draw(SDLScreen);
        if(!Effect->Done)
            SDL_UpdateRect(SDLScreen,Effect->StartX,Effect->StartY,Effect->EndX - Effect->StartX,Effect->EndY - Effect->StartY);
        else
            SDL_Flip(SDLScreen);
        FrameCounter++;

        while (SDL_PollEvent(&Event))
        {

            if (Event.type == SDL_QUIT)
                GameState=GSQuit;
            if (Event.type == SDL_MOUSEBUTTONUP)
            {
                Mix_PlayChannel(-1,Sounds[SND_Select],0);
                PreviousGameState = GameState;
                GameState=GSTitleScreen;
            }

            if ((Event.type == SDL_KEYDOWN))
            {
                switch(Event.key.keysym.sym)
                {
                    case SDLK_PLUS:
                        IncVolume();
                        break;

                    case SDLK_MINUS:
                        DecVolume();
                        break;

                    case SDLK_l:
                        NextSkin();
                        WorldParts->AssignImage(IMGBlocks);
                        break;

                    default:
                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                        PreviousGameState = GameState;
                        GameState=GSTitleScreen;
                        break;

                }
            }

        }
        if(Time + 1000 < SDL_GetTicks())
        {

            FPS = FrameCounter;
            FrameCounter =0;
            Time=SDL_GetTicks();
        }
        SDL_framerateDelay(&Fpsman);


    }
    delete Effect;
}

void Credits()
{
    SDL_Event Event;
    char Text[512];
    Uint32 Time = 0;
    int FPS=0,FrameCounter=0;
    Movement = MNone;
    CEffects *Effect = new CEffects(SDLScreen,0,0,799,479);
    srand((int) time(NULL));
    Effect->BlockRemove(10,2000,5,5);
    Score=0;
    while (GameState == GSCredits)
    {
         if(GlobalSoundEnabled)
            if (! Mix_PlayingMusic())
            {
                SelectedMusic =	rand()%(MusicCount);
                Mix_PlayMusic(Music[SelectedMusic],0);
                SetVolume(Volume);
            }

        while (SDL_PollEvent(&Event))
        {

            if (Event.type == SDL_QUIT)
                GameState=GSQuit;
            if (Event.type == SDL_MOUSEBUTTONUP)
            {
                PreviousGameState = GameState;
                GameState = GSTitleScreen;

            }

            if ((Event.type == SDL_KEYDOWN))
            {
                switch(Event.key.keysym.sym)
                {
                    case SDLK_PLUS:
                        IncVolume();
                        break;

                    case SDLK_MINUS:
                        DecVolume();
                        break;

                    case SDLK_l:
                        NextSkin();
                        WorldParts->AssignImage(IMGBlocks);
                        break;

                    default:
                        PreviousGameState = GameState;
                        GameState = GSTitleScreen;
                        break;

                }
            }

        }

        SDL_BlitSurface(IMGTitleScreen,NULL,SDLScreen,NULL);
        sprintf(Text,"Puztrix was created by\nWillems Davy, Willems Soft 2009\n\nPuztrix is a remake of gravnic,\nwhich is part of puznic, a\ngame for the nintendo console.\n\nMusic was created by\nradiance of iris - 1996\nTaken from the modarchive\n\nSounds created using sfxr");
        WriteText(SDLScreen,font,Text,strlen(Text),230,120,-3,TextColor);
        Effect->DoEffect();
        Effect->Draw(SDLScreen);
        if(!Effect->Done)
            SDL_UpdateRect(SDLScreen,Effect->StartX,Effect->StartY,Effect->EndX - Effect->StartX,Effect->EndY - Effect->StartY);
        else
            SDL_Flip(SDLScreen);
        FrameCounter++;

        if(Time + 1000 < SDL_GetTicks())
        {

            FPS = FrameCounter;
            FrameCounter =0;
            Time=SDL_GetTicks();
        }
        SDL_framerateDelay(&Fpsman);


    }
    delete Effect;
}


void TitleScreen()
{
    SDL_Event Event;
    char Text[512];
    Uint32 Time = 0;
    int FPS=0,FrameCounter=0;
    Movement = MNone;
    CEffects *Effect = new CEffects(SDLScreen,0,0,799,479);
    srand((int) time(NULL));
    Effect->BlockRemove(10,2000,5,5);
    Score=0;
    while (GameState == GSTitleScreen)
    {
         if(GlobalSoundEnabled)
            if (! Mix_PlayingMusic())
            {
                SelectedMusic =	rand()%(MusicCount);
                Mix_PlayMusic(Music[SelectedMusic],0);
                SetVolume(Volume);
            }

        while (SDL_PollEvent(&Event))
        {

            if (Event.type == SDL_QUIT)
                GameState=GSQuit;
            if (Event.type == SDL_MOUSEBUTTONUP)
            {
                if((Event.button.x > 240) && (Event.button.x < 240+275) && (Event.button.y > 130) && (Event.button.y < 130+40))
                {
                    Mix_PlayChannel(-1,Sounds[SND_Select],0);
                    WorldParts->LoadLevelPack(InstalledLevelPacks[SelectedLevelPack],StartPath);
                    WorldParts->SetLevel(1);
                    Retries = 5;
                    Score = 0;
                    PreviousGameState = GameState;
                    GameState=GSGame;
                }
                else
                    if((Event.button.x > 240) && (Event.button.x < 240+275) && (Event.button.y > 180) && (Event.button.y < 180+40))
                    {
                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                        PreviousGameState = GameState;
                        GameState=GSLevelEditor;
                        WorldParts->LoadLevelPack(InstalledLevelPacks[SelectedLevelPack],StartPath);
                        WorldParts->SetLevel(1);
                    }
                    else
                        if((Event.button.x > 240) && (Event.button.x < 240+275) && (Event.button.y > 230) && (Event.button.y < 230+40))
                        {
                            Mix_PlayChannel(-1,Sounds[SND_Select],0);
                            SelectedLevelPack++;
                            if(SelectedLevelPack >= InstalledLevelPacksCount)
                                SelectedLevelPack = 0;
                        }
                        else
                            if((Event.button.x > 240) && (Event.button.x < 240+275) && (Event.button.y > 280) && (Event.button.y < 280+40))
                            {
                                Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                PreviousGameState = GameState;
                                GameState=GSCredits;
                            }
                            else
                                if((Event.button.x > 240) && (Event.button.x < 240+275) && (Event.button.y > 330) && (Event.button.y < 330+40))
                                {
                                    Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                    GameState = GSQuit;
                                }


            }

            if ((Event.type == SDL_KEYDOWN))
            {
                switch(Event.key.keysym.sym)
                {
                    case SDLK_PLUS:
                        IncVolume();
                        break;

                    case SDLK_MINUS:
                        DecVolume();
                        break;

                    case SDLK_l:
                        NextSkin();
                        WorldParts->AssignImage(IMGBlocks);
                        break;

                    default:
                        WorldParts->LoadLevelPack(InstalledLevelPacks[SelectedLevelPack],StartPath);
                        WorldParts->SetLevel(1);
                        Retries = 5;
                        Score = 0;
                        PreviousGameState = GameState;
                        GameState=GSGame;
                        break;

                }
            }

        }

        SDL_BlitSurface(IMGTitleScreen,NULL,SDLScreen,NULL);
        sprintf(Text,"Play\nLevel Editor\n<%s>\nCredits\nQuit",InstalledLevelPacks[SelectedLevelPack]);
        WriteText(SDLScreen,BigFont,Text,strlen(Text),240,130,8,TextColor);
        Effect->DoEffect();
        Effect->Draw(SDLScreen);
        if(!Effect->Done)
            SDL_UpdateRect(SDLScreen,Effect->StartX,Effect->StartY,Effect->EndX - Effect->StartX,Effect->EndY - Effect->StartY);
        else
            SDL_Flip(SDLScreen);
        FrameCounter++;

        if(Time + 1000 < SDL_GetTicks())
        {

            FPS = FrameCounter;
            FrameCounter =0;
            Time=SDL_GetTicks();
        }
        SDL_framerateDelay(&Fpsman);


    }
    delete Effect;
}



void GameOver()
{

    SDL_Event Event;
    char Text[512];
    Uint32 Time = 0;
    int FPS=0,FrameCounter=0;
    Movement = MNone;
    Mix_PlayChannel(-1,Sounds[SND_GameOver],0);
    CEffects *Effect = new CEffects(SDLScreen,330,0,800-330-1,479);
    srand((int) time(NULL));
    switch(rand() % 5)
    {
        case 3:
            Effect->VerticalLine(10,20,3);
            break;
        case 2:
            Effect->HorizontalLine(10,20,3);
            break;
        case 1:
            Effect->BlockRemove(10,2000,5,5);
            break;
        case 4:
            Effect->PixelRemove(10,25000);
            break;
        case 0:
            Effect->Alpha(5,50);
            break;
    }

    while (GameState == GSGameOver )
    {
         if(GlobalSoundEnabled)
            if (! Mix_PlayingMusic())
            {
                SelectedMusic =	rand()%(MusicCount);
                Mix_PlayMusic(Music[SelectedMusic],0);
                SetVolume(Volume);
            }

        while (SDL_PollEvent(&Event))
        {

            if (Event.type == SDL_QUIT)
                GameState=GSQuit;
            if (Event.type == SDL_MOUSEBUTTONUP)
            {
                Mix_PlayChannel(-1,Sounds[SND_Select],0);
                PreviousGameState = GameState;
                GameState=GSTitleScreen;
            }

            if ((Event.type == SDL_KEYDOWN))
            {
                switch(Event.key.keysym.sym)
                {
                    case SDLK_PLUS:
                        IncVolume();
                        break;

                    case SDLK_MINUS:
                        DecVolume();
                        break;

                    case SDLK_l:
                        NextSkin();
                        WorldParts->AssignImage(IMGBlocks);
                        break;

                    default:
                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                        PreviousGameState = GameState;
                        GameState=GSTitleScreen;
                        break;

                }
            }

        }
        SDL_BlitSurface(IMGGameOver,NULL,SDLScreen,NULL);
        sprintf(Text,"Score: %d\nLevel Number: %d\nMoves Left: %d\nRetry: %d\n",Score,WorldParts->GetLevel(),MaxMoves,Retries);
        WriteText(SDLScreen,font,Text,strlen(Text),42,100,0,TextColor);
        DrawArrows(SDLScreen);
        Effect->DoEffect();
        Effect->Draw(SDLScreen);
        if(!Effect->Done)
            SDL_UpdateRect(SDLScreen,Effect->StartX,Effect->StartY,Effect->EndX - Effect->StartX,Effect->EndY - Effect->StartY);
        else
            SDL_Flip(SDLScreen);
        FrameCounter++;
        if(Time + 1000 < SDL_GetTicks())
        {

            FPS = FrameCounter;
            FrameCounter =0;
            Time=SDL_GetTicks();
        }
        SDL_framerateDelay(&Fpsman);


    }
    delete Effect;


//
//    else
//    {
//        Levelpack done
//    }

}


void Game()
{
    SDL_Event Event;
    MaxMoves = WorldParts->LevelMoves;
    char Text[512];
    Uint32 Time = 0;
    int FPS=0,FrameCounter=0;
    int X,Y;
    bool KeyPressed;
    int MouseSelection = -1;
    CEffects *Effect;
    if((PreviousGameState == GSTitleScreen) || (PreviousGameState == GSLevelEditor))
    {
        Effect = new CEffects(SDLScreen,0,0,799,479);
        Effect->BlockRemove(10,2000,5,5);
    }
    else
    {
        Effect = new CEffects(SDLScreen,330,0,800-330-1,479);
        srand((int) time(NULL));
        switch(rand() % 5)
        {
            case 0:
                Effect->VerticalLine(10,20,3);
                break;
            case 1:
                Effect->HorizontalLine(10,20,3);
                break;
            case 2:
                Effect->BlockRemove(10,2000,5,5);
                break;
            case 3:
                Effect->PixelRemove(10,25000);
                break;
            case 4:
                Effect->Alpha(5,50);
                break;
        }
    }
    Movement = MNone;
    while (GameState == GSGame)
    {

        if(GlobalSoundEnabled)
            if (! Mix_PlayingMusic())
            {
                SelectedMusic =	rand()%(MusicCount);
                Mix_PlayMusic(Music[SelectedMusic],0);
                SetVolume(Volume);
            }
        //Moet in deze volgorde !!!!

        //1) als we niet moven en er zijn geen deathblocks blijf moven in de richting die we gingen
        if(!WorldParts->IsMoving())
        {


            for (X=0;X<NrOfCols;X++)
                for (Y=0;Y<NrOfRows;Y++)
                    if(EraseBlocks(WorldParts,X,Y) > 1)
                        if(GlobalSoundEnabled)
                            Mix_PlayChannel(-1,Sounds[SND_Destroy],0);



            if(!DeathBlocks(WorldParts))
            switch (Movement)
            {
                case MLeft:
                    WorldParts->MoveLeft();
                    break;
                case MRight:
                    WorldParts->MoveRight();
                    break;
                case MUp:
                    WorldParts->MoveUp();
                    break;
                case MDown:
                    WorldParts->MoveDown();
                    break;
                default:
                    break;
            }
        }

        //2) Zet de richting die we willen moven en start moving zo dat ismoving true teruggeeft
        KeyPressed = false;
        while (SDL_PollEvent(&Event))
        {

            if (Event.type == SDL_QUIT)
                GameState=GSQuit;

            if (Event.type == SDL_MOUSEBUTTONUP)
            {
                if((Event.button.x > 18) && (Event.button.x < 18+272) && (Event.button.y > 7) && (Event.button.y < 7 + 72))
                {
                    Mix_PlayChannel(-1,Sounds[SND_Select],0);
                    if(PreviousGameState == GSLevelEditor)
                    {
                        PreviousGameState = GameState;
                        GameState = GSLevelEditor;
                        WorldParts->LoadLevel();
                        Retries = 5;
                    }
                    else
                    {
                        PreviousGameState = GameState;
                        GameState = GSTitleScreen;
                    }

                }
                else
                if(Effect->Done)
                    if(MaxMoves > 0)
                        if(!DeathBlocks(WorldParts))
                            if(!WorldParts->IsMoving())
                            {
                                MouseSelection = GetMouseSelection(Event.button.x,Event.button.y);
                                switch (MouseSelection)
                                {
                                    case MUp:
                                        if(WorldParts->CanMoveToUp())
                                        {
                                            WorldParts->MoveUp();
                                            Movement = MUp;
                                            MaxMoves--;
                                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                                        }
                                        break;
                                    case MDown:
                                        if(WorldParts->CanMoveToDown())
                                        {
                                            WorldParts->MoveDown();
                                            Movement = MDown;
                                            MaxMoves--;
                                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                                        }
                                        break;
                                    case MRight:
                                        if(WorldParts->CanMoveToRight())
                                        {
                                            WorldParts->MoveRight();
                                            Movement = MRight;
                                            MaxMoves--;
                                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                                        }
                                        break;
                                    case MLeft:
                                        if(WorldParts->CanMoveToLeft())
                                        {
                                            WorldParts->MoveLeft();
                                            Movement = MLeft;
                                            MaxMoves--;
                                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                                        }
                                        break;
                                    default:
                                        break;
                                }
                            }

            }

            if ((Event.type == SDL_KEYDOWN) && !KeyPressed)
            {
                switch(Event.key.keysym.sym)
                {
                    case SDLK_PLUS:
                        IncVolume();
                        break;

                    case SDLK_MINUS:
                        DecVolume();
                        break;

                    case SDLK_l:
                        if(Effect->Done)
                        {
                            NextSkin();
                            WorldParts->AssignImage(IMGBlocks);
                        }
                        break;

                    case SDLK_RETURN:
                        if(Effect->Done && (Movement != MNone))
                        {
                            if(GlobalSoundEnabled)
                                Mix_PlayChannel(-1,Sounds[SND_NoMoves],0);
                            Movement = MNone;
                            Retries--;
                            if(Retries == -1)
                            {
                                if(PreviousGameState == GSLevelEditor)
                                {
                                    PreviousGameState = GameState;
                                    GameState = GSLevelEditor;
                                    WorldParts->LoadLevel();
                                    Retries = 5;
                                }
                                else
                                {
                                    GameState = GSGameOver;
                                    Retries = 0;
                                }
                            }
                            else
                            {
                                WorldParts->SetLevel(WorldParts->GetLevel());
                                MaxMoves = WorldParts->LevelMoves;
                            }



                        }
                        break;

                    case SDLK_LEFT:
                        if(Effect->Done)
                        if(MaxMoves > 0)
                        if(!DeathBlocks(WorldParts))
                        if(!WorldParts->IsMoving())
                        if(WorldParts->CanMoveToLeft())
                        {
                            WorldParts->MoveLeft();
                            Movement = MLeft;
                            MaxMoves--;
                            KeyPressed = true;
                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                        }
                        break;

                    case SDLK_RIGHT:
                        if(Effect->Done)
                        if(MaxMoves > 0)
                        if(!DeathBlocks(WorldParts))
                        if(!WorldParts->IsMoving())
                        if(WorldParts->CanMoveToRight())
                        {
                            WorldParts->MoveRight();
                            Movement = MRight;
                            MaxMoves--;
                            KeyPressed = true;
                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                        }
                        break;

                    case SDLK_UP:
                        if(Effect->Done)
                        if(MaxMoves > 0)
                        if(!DeathBlocks(WorldParts))
                        if(!WorldParts->IsMoving())
                        if(WorldParts->CanMoveToUp())
                        {
                            WorldParts->MoveUp();
                            Movement = MUp;
                            MaxMoves--;
                            KeyPressed = true;
                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                        }
                        break;

                    case SDLK_DOWN:
                        if(Effect->Done)
                        if(MaxMoves > 0)
                        if(!DeathBlocks(WorldParts))
                        if(!WorldParts->IsMoving())
                        if(WorldParts->CanMoveToDown())
                        {
                            WorldParts->MoveDown();
                            Movement = MDown;
                            MaxMoves--;
                            KeyPressed = true;
                            Mix_PlayChannel(-1,Sounds[SND_DirectionMove],0);
                        }
                        break;

                    default:
                        break;

                }
            }

        }

        if(LevelWon(WorldParts))
        {
            if(PreviousGameState == GSLevelEditor)
            {
                PreviousGameState = GameState;
                GameState = GSLevelEditor;
                WorldParts->LoadLevel();
                Retries = 5;
            }
            else
            {
                PreviousGameState = GameState;
                GameState = GSStageClear;
            }

        }

        //3) anders wordt dit true als we bij 2 ni starten met moven en stopt het direct wanneer er geen moves meer over zijn
        if((MaxMoves == 0) && !WorldParts->IsMoving() && !DeathBlocks(WorldParts) && (GameState != GSStageClear) && (GameState != GSLevelEditor))
        {
            if(GlobalSoundEnabled)
                Mix_PlayChannel(-1,Sounds[SND_NoMoves],0);
            Movement = MNone;
            Retries--;
            if(Retries == -1)
            {
                if(PreviousGameState == GSLevelEditor)
                {
                    PreviousGameState = GameState;
                    GameState = GSLevelEditor;
                    WorldParts->LoadLevel();
                    Retries = 5;
                }
                else
                {
                    GameState = GSGameOver;
                    Retries = 0;
                }
            }
            else
            {
                WorldParts->SetLevel(WorldParts->GetLevel());
                MaxMoves = WorldParts->LevelMoves;
            }
        }

        if(NoMovesLeft(WorldParts))
        {
            if(GlobalSoundEnabled)
                Mix_PlayChannel(-1,Sounds[SND_NoMoves],0);
            Movement = MNone;
            Retries--;
            if(Retries == -1)
            {
                if(PreviousGameState == GSLevelEditor)
                {
                    PreviousGameState = GameState;
                    GameState = GSLevelEditor;
                    WorldParts->LoadLevel();
                    Retries = 5;
                }
                else
                {
                    GameState = GSGameOver;
                    Retries = 0;
                }
            }
            else
            {
                WorldParts->SetLevel(WorldParts->GetLevel());
                MaxMoves = WorldParts->LevelMoves;
            }
        }

        WorldParts->Move();


        SDL_BlitSurface(IMGBackground,NULL,SDLScreen,NULL);
        sprintf(Text,"Score: %d\nLevel Number: %d\nMoves Left: %d\nRetry: %d\n",Score,WorldParts->GetLevel(),MaxMoves,Retries);
        WriteText(SDLScreen,font,Text,strlen(Text),42,100,0,TextColor);
        DrawFloor(WorldParts,SDLScreen);
        WorldParts->Draw(SDLScreen); //bij draw event van blocks wordt de death en remove flag gezet
        DrawArrows(SDLScreen);
        Effect->DoEffect();
        Effect->Draw(SDLScreen);
        RemoveBlocks(WorldParts); // Dus wis deze blokken als er zouden zijn

        if(!Effect->Done)
            SDL_UpdateRect(SDLScreen,Effect->StartX,Effect->StartY,Effect->EndX - Effect->StartX,Effect->EndY - Effect->StartY);
        else
            SDL_Flip(SDLScreen);
        FrameCounter++;
        if(Time + 1000 < SDL_GetTicks())
        {

            FPS = FrameCounter;
            FrameCounter =0;
            Time=SDL_GetTicks();
        }

        SDL_framerateDelay(&Fpsman);


    }
    delete Effect;

}

bool CanPlay(CWorldParts *aWorldParts)
{
    int Teller,NumBlock1=0,NumBlock2=0,NumBlock3=0;
    for(Teller=0;Teller<aWorldParts->ItemCount;Teller++)
    {
        if(aWorldParts->Items[Teller]->GetType() == 1)
            NumBlock1++;
        if(aWorldParts->Items[Teller]->GetType() == 2)
            NumBlock2++;
        if(aWorldParts->Items[Teller]->GetType() == 3)
            NumBlock3++;

    }
    return ((NumBlock1 >= 2) || (NumBlock2 >= 2) || (NumBlock3 >=2));

}

void LevelEditor()
{
    SDL_Event Event;
    char FileName[FILENAME_MAX+PATH_MAX];
    char Text[512];
    Uint32 Time = 0;
    int FPS=0,FrameCounter=0,Teller=0,SelectedBlock=0;
    CEffects *Effect;
    SDL_Rect Dst,Src;
    if((PreviousGameState == GSTitleScreen) || (PreviousGameState == GSGame))
    {
        Effect = new CEffects(SDLScreen,0,0,799,479);
        Effect->BlockRemove(10,2000,5,5);
    }
    else
    {
        Effect = new CEffects(SDLScreen,330,0,800-330-1,479);
        srand((int) time(NULL));
        switch(rand() % 5)
        {
            case 0:
                Effect->VerticalLine(10,20,3);
                break;
            case 1:
                Effect->HorizontalLine(10,20,3);
                break;
            case 2:
                Effect->BlockRemove(10,2000,5,5);
                break;
            case 3:
                Effect->PixelRemove(10,25000);
                break;
            case 4:
                Effect->Alpha(5,50);
                break;
        }
    }
    while (GameState == GSLevelEditor)
    {

        if(GlobalSoundEnabled)
            if (! Mix_PlayingMusic())
            {
                SelectedMusic =	rand()%(MusicCount);
                Mix_PlayMusic(Music[SelectedMusic],0);
                SetVolume(Volume);
            }


        while (SDL_PollEvent(&Event))
        {

            if (Event.type == SDL_QUIT)
                GameState=GSQuit;

            if (Event.type == SDL_MOUSEBUTTONUP)
            {
                if(Effect->Done)
                {
                    if((Event.button.x > 18) && (Event.button.x < 18+272) && (Event.button.y > 7) && (Event.button.y < 7 + 72))
                    {
                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                        PreviousGameState = GameState;
                        GameState = GSTitleScreen;
                    }
                    else
                    if((Event.button.x >=Xoffset) && (Event.button.x < Xoffset+(NrOfCols*TileWidth) ) && (WorldParts->LevelCount > 0))
                    {
                        if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                        {
                            if(WorldParts->GetLevel() > 0)
                            {
                                Mix_PlayChannel(-1,Sounds[SND_LevelEditorSelect],0);
                                WorldParts->Remove((Event.button.x - Xoffset) / TileWidth,Event.button.y/TileHeight);
                                if(SelectedBlock < 5)
                                    WorldParts->Add(new CBox((Event.button.x - Xoffset)/ TileWidth,Event.button.y/TileHeight,WorldParts->GetAssignedImage(),SelectedBlock+1));
                            }
                            else
                                Mix_PlayChannel(-1,Sounds[SND_Error],0);

                        }
                        else
                            Mix_PlayChannel(-1,Sounds[SND_Error],0);
                    }
                    else
                    {
                        if((Event.button.x >= 33) && (Event.button.x <33+(6*TileWidth)) && (Event.button.y >=230) && (Event.button.y < 230+TileHeight))
                        {
                            if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                            {
                                if(WorldParts->GetLevel() > 0)
                                {
                                    Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                    SelectedBlock = (Event.button.x - 33) / TileWidth;
                                }
                                else
                                    Mix_PlayChannel(-1,Sounds[SND_Error],0);

                            }
                            else
                                Mix_PlayChannel(-1,Sounds[SND_Error],0);
                        }
                        else
                            if((Event.button.x >= 30) && (Event.button.x <30+115) && (Event.button.y >=280) && (Event.button.y < 280+25))
                            {

                                if(WorldParts->GetLevel() < WorldParts->LevelCount)
                                    Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                else
                                    Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                {
                                    WorldParts->SaveLevel();
                                }
                                WorldParts->IncLevel();
                            }
                            else
                                if((Event.button.x >= 30+120) && (Event.button.x <30+115+120) && (Event.button.y >=280) && (Event.button.y < 280+25))
                                {
                                    if(WorldParts->GetLevel() > 1)
                                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                    else
                                        Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                    if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                    {
                                        WorldParts->SaveLevel();
                                    }
                                    WorldParts->DecLevel();
                                }
                                else
                                    if((Event.button.x >= 30) && (Event.button.x <30+115) && (Event.button.y >=310) && (Event.button.y < 310+25))
                                    {
                                        if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                        {
                                            Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                            WorldParts->SaveLevel();
                                            WorldParts->AddLevel();
                                        }
                                        else
                                            Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                    }
                                    else
                                        if((Event.button.x >= 30+120) && (Event.button.x <30+115+120) && (Event.button.y >=310) && (Event.button.y < 310+25))
                                        {
                                            if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                            {
                                                if(WorldParts->GetLevel() > 0)
                                                {
                                                    Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                    WorldParts->DelLevel();
                                                }
                                                else
                                                    Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                            }
                                            else
                                                Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                        }
                                        else
                                            if((Event.button.x >= 30) && (Event.button.x <30+115) && (Event.button.y >=340) && (Event.button.y < 340+25))
                                            {
                                                if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                                {
                                                    if(WorldParts->GetLevel() > 0)
                                                    {
                                                        WorldParts->LevelMoves++;
                                                        if(WorldParts->LevelMoves > 100)
                                                        {
                                                            Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                            WorldParts->LevelMoves = 100;
                                                        }
                                                        else
                                                            Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                    }
                                                    else
                                                        Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                }
                                                else
                                                    Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                            }
                                            else
                                                if((Event.button.x >= 30+120) && (Event.button.x <30+115+120) && (Event.button.y >=340) && (Event.button.y < 340+25))
                                                {
                                                    if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                                    {
                                                        if(WorldParts->GetLevel() > 0)
                                                        {
                                                            WorldParts->LevelMoves--;
                                                            if(WorldParts->LevelMoves < 1)
                                                            {
                                                                Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                                WorldParts->LevelMoves = 1;
                                                            }
                                                            else
                                                                Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                        }
                                                        else
                                                            Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                    }
                                                    else
                                                        Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                }
                                                else
                                                    if((Event.button.x >= 30) && (Event.button.x <30+115) && (Event.button.y >=370) && (Event.button.y < 370+25))
                                                    {
                                                        if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                                        {
                                                            Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                            WorldParts->SaveLevel();
                                                            WorldParts->SaveLevelPack(InstalledLevelPacks[SelectedLevelPack],StartPath);
                                                        }
                                                        else
                                                            Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                    }
                                                    else
                                                        if((Event.button.x >= 30+120) && (Event.button.x <30+115+120) && (Event.button.y >=370) && (Event.button.y < 370+25))
                                                        {
                                                            if(InstalledLevelPacksCount+1<MaxLevelPacks)
                                                            {
                                                                Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                                WorldParts->NewLevelPack();
                                                                Teller=1;
                                                                sprintf(FileName,"%slevels/my_levels%d.dat",StartPath,Teller);
                                                                while(FileExists(FileName))
                                                                {
                                                                    Teller++;
                                                                    sprintf(FileName,"%slevels/my_levels%d.dat",StartPath,Teller);
                                                                }
                                                                sprintf(FileName,"my_levels%d.dat",Teller);
                                                                WorldParts->SaveLevelPack(FileName,StartPath);
                                                                SearchForLevelPacks();
                                                                for(Teller = 0;Teller<InstalledLevelPacksCount;Teller++)
                                                                    if(strcmp(FileName,InstalledLevelPacks[Teller]) == 0)
                                                                    {
                                                                        SelectedLevelPack = Teller;
                                                                        break;
                                                                    }
                                                            }
                                                            else
                                                                Mix_PlayChannel(-1,Sounds[SND_Error],0);

                                                        }
                                                        else
                                                            if((Event.button.x >= 30) && (Event.button.x <30+115) && (Event.button.y >=400) && (Event.button.y < 400+25))
                                                            {
                                                                if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                                                {
                                                                    if(WorldParts->GetLevel() > 0)
                                                                    {
                                                                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                                        WorldParts->RemoveAll();
                                                                    }
                                                                    else
                                                                        Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                                }
                                                                else
                                                                    Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                            }
                                                            else
                                                                if((Event.button.x >= 30+120) && (Event.button.x <30+115+120) && (Event.button.y >=400) && (Event.button.y < 400+25))
                                                                {
                                                                    if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                                                    {
                                                                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                                        sprintf(FileName,"%slevels/%s",StartPath,InstalledLevelPacks[SelectedLevelPack]);
                                                                        remove(FileName);
#ifdef N810
                                                                        sync();
#endif
                                                                        SearchForLevelPacks();
                                                                        WorldParts->LoadLevelPack(InstalledLevelPacks[SelectedLevelPack],StartPath);
                                                                        WorldParts->SetLevel(1);
                                                                    }
                                                                    else
                                                                        Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                                }
                                                                else
                                                                    if((Event.button.x >= 30) && (Event.button.x <30+115) && (Event.button.y >=430) && (Event.button.y < 430+25))
                                                                    {
                                                                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                                        Grid++;
                                                                        if (Grid > 2)
                                                                            Grid = 0;
                                                                    }
                                                                    else
                                                                        if((Event.button.x >= 30+120) && (Event.button.x <30+115+120) && (Event.button.y >=430) && (Event.button.y < 430+25))
                                                                        {
                                                                            if(!(strcmp(InstalledLevelPacks[SelectedLevelPack],"levels.dat")==0))
                                                                            {
                                                                                if(WorldParts->LevelCount > 0)
                                                                                {
                                                                                    if(CanPlay(WorldParts))
                                                                                    {
                                                                                        Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                                                        WorldParts->SaveLevel();
                                                                                        PreviousGameState = GameState;
                                                                                        GameState = GSGame;
                                                                                    }
                                                                                    else
                                                                                        Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                                                }
                                                                                else
                                                                                    Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                                            }
                                                                            else
                                                                                Mix_PlayChannel(-1,Sounds[SND_Error],0);
                                                                        }
                                                                        else
                                                                            if((Event.button.x >= 40) && (Event.button.x <270) && (Event.button.y >=100) && (Event.button.y < 125))
                                                                            {
                                                                                Mix_PlayChannel(-1,Sounds[SND_Select],0);
                                                                                SelectedLevelPack++;
                                                                                if(SelectedLevelPack >= InstalledLevelPacksCount)
                                                                                    SelectedLevelPack = 0;
                                                                                WorldParts->LoadLevelPack(InstalledLevelPacks[SelectedLevelPack],StartPath);
                                                                                WorldParts->SetLevel(1);
                                                                            }

                    }
                }
            }

            if ((Event.type == SDL_KEYDOWN))
            {
                switch(Event.key.keysym.sym)
                {
                    case SDLK_PLUS:
                        IncVolume();
                        break;

                    case SDLK_MINUS:
                        DecVolume();
                        break;

                    case SDLK_l:
                        if(Effect->Done)
                        {
                            NextSkin();
                            WorldParts->AssignImage(IMGBlocks);
                        }
                        break;

                    default:
                        break;

                }
            }

        }

        SDL_BlitSurface(IMGBackgroundLevelEditor,NULL,SDLScreen,NULL);
        sprintf(Text,"%s\nLevel Number: %d/%d\nMoves: %d\nGrid: %d\n",InstalledLevelPacks[SelectedLevelPack], WorldParts->GetLevel(),WorldParts->LevelCount,WorldParts->LevelMoves,Grid);
        WriteText(SDLScreen,font,Text,strlen(Text),42,100,0,TextColor);
        sprintf(Text,"Next Level  Prev Level\nAdd Level   Del Level\nInc Moves   Dec Moves\nSave Pack   New Pack\nClear Level  Del Pack\nGrid            Play");
        WriteText(SDLScreen,font,Text,strlen(Text),33,280,4,TextColor);


        if(Grid == 2)
        {
            Dst.x = Xoffset;
            Dst.y = Yoffset;
            Dst.w = NrOfCols * TileWidth;
            Dst.h = NrOfRows * TileHeight;
            SDL_FillRect(SDLScreen,&Dst,SDL_MapRGB(SDLScreen->format,255,255,255));
        }
        DrawFloor(WorldParts,SDLScreen);
        WorldParts->Draw(SDLScreen);
        for(Teller=0;Teller<6;Teller++)
        {
            Src.x = 0;
            Src.y = TileHeight*Teller;
            Src.w = TileWidth;
            Src.h = TileHeight;
            Dst.x = 33 +(TileWidth*Teller);
            Dst.y = 230;
            Dst.w = TileWidth;
            Dst.h = TileHeight;
            SDL_BlitSurface(IMGBlocks,&Src,SDLScreen,&Dst);
        }
        boxRGBA(SDLScreen,33+(TileWidth*SelectedBlock),230-2,33+(TileWidth*(SelectedBlock+1))-1,230-4,255,255,255,255);
        boxRGBA(SDLScreen,33+(TileWidth*SelectedBlock),230+TileHeight+2,33+(TileWidth*(SelectedBlock+1))-1,230+TileHeight+4,255,255,255,255);
        if(Grid >=1)
        {
            Dst.x = Xoffset;
            Dst.y = Yoffset;
            Dst.w = NrOfCols * TileWidth;
            Dst.h = NrOfRows * TileHeight;
            SDL_BlitSurface(IMGGrid,NULL,SDLScreen,&Dst);
        }
        Effect->DoEffect();
        Effect->Draw(SDLScreen);


        if(!Effect->Done)
            SDL_UpdateRect(SDLScreen,Effect->StartX,Effect->StartY,Effect->EndX - Effect->StartX,Effect->EndY - Effect->StartY);
        else
            SDL_Flip(SDLScreen);
        FrameCounter++;
        if(Time + 1000 < SDL_GetTicks())
        {

            FPS = FrameCounter;
            FrameCounter =0;
            Time=SDL_GetTicks();
        }
        SDL_framerateDelay(&Fpsman);


    }
    delete Effect;

}


void GetFilePath(char *InputFile,char *result)
{
    int Teller,Pos=0;
    for(Teller=strlen(InputFile)-1;Teller>=0;Teller--)
        if(InputFile[Teller] == '/' || InputFile[Teller] == '\\')
        {
            Pos = Teller+1;
            break;
        }
    memcpy(result,InputFile,Pos);
}


int main(int argc, char **argv)
{
#ifdef N810
    putenv("SDL_VIDEO_X11_WMCLASS=puztrix");
    char title[50];
	title[49] = '\0';
#endif

	char Filename[PATH_MAX+FILENAME_MAX];
	GetFilePath(argv[0],StartPath);
	WorldParts = new CWorldParts();
	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO ) == 0)
	{
		printf("SDL Succesfully initialized\n");
#ifdef N810
		SDLScreen = SDL_SetVideoMode( 800 ,480,16, SDL_HWSURFACE | SDL_FULLSCREEN );
#else
        SDLScreen = SDL_SetVideoMode( 800 ,480,16, SDL_HWSURFACE );
#endif
		if(SDLScreen)
		{
		    SDL_WM_SetCaption("Puztrix","Puztrix");
#ifdef N810
            char *caption;
			SDL_WM_GetCaption(&caption, NULL);
            strncpy(title,caption,49);
            SDL_SysWMinfo info;
            SDL_VERSION(&info.version);
            if ( SDL_GetWMInfo(&info) )
            {
                Display *dpy = info.info.x11.display;
                Window win;
				win = info.info.x11.fswindow;
                XStoreName(dpy, win, title);
            }
#endif
		    SDL_FillRect(SDLScreen,NULL,SDL_MapRGB(SDLScreen->format,0,0,0));
		    printf("Succesfully Set %dx%dx16\n",800,480);
			SDL_ShowCursor(SDL_ENABLE);
#ifdef N810
			if (Mix_OpenAudio(22050,AUDIO_S16,MIX_DEFAULT_CHANNELS,128) < 0)
#else
            if (Mix_OpenAudio(22050,AUDIO_S16,MIX_DEFAULT_CHANNELS,512) < 0)
#endif
            {
                GlobalSoundEnabled = false;
                printf("Failed to initialise sound!\n");
                printf("%s\n",Mix_GetError());
            }
            else
            {
                printf("Audio Succesfully initialised!\n");
            }
            if (TTF_Init() == 0)
            {
                printf("Succesfully initialized TTF\n");
                sprintf(Filename,"%sdata/font.ttf",StartPath);
                font = TTF_OpenFont(Filename,20);
                BigFont = TTF_OpenFont(Filename,32);
                if (font&&BigFont)
                {
                    printf("Succesfully Loaded fonts\n");
                    TTF_SetFontStyle(font,TTF_STYLE_NORMAL);
                    SDL_initFramerate(&Fpsman);
                    SDL_setFramerate(&Fpsman,FixedFPS);
                    SearchForLevelPacks();
                    SearchForSkins();
                    SearchForMusic();
                    LoadSounds();
                    LoadGraphics();
                    LoadSettings();
                    WorldParts->AssignImage(IMGBlocks);
                    Retries = 5;
                    Score = 0;
                    while (GameState != GSQuit)
                    {
                        switch(GameState)
                        {
                            case GSTitleScreen:
                                TitleScreen();
                                break;
                            case GSLevelpackDone:
                                LevelpackDone();
                                break;
                            case GSGame :
                                Game();
                                break;
                            case GSStageClear:
                                StageClear();
                                break;
                            case GSGameOver:
                                GameOver();
                                break;
                            case GSLevelEditor:
                                LevelEditor();
                                break;
                            case GSCredits:
                                Credits();
                                break;
                            default :
                                break;
                        }
                    }
                    SaveSettings();
                    UnLoadGraphics();
                    UnloadSounds();
                    UnloadMusic();
                    TTF_CloseFont(font);
                    font=NULL;
                }
                else
                {
                    printf("Failed to Load fonts\n");
                }
                TTF_Quit();
            }
            else
            {
                printf("Failed to initialize TTF\n");
            }
            SDL_FreeSurface(SDLScreen);
            SDLScreen=NULL;
            SDLScreen=NULL;
            Mix_CloseAudio();
		}
		else
		{
			printf("Failed to Set Videomode %dx%dx16\n",800, 480);
		}
		SDL_Quit();
	}
	else
	{
		printf("Couldn't initialise SDL!\n");
	}
	WorldParts->RemoveAll();
	//since the destructor isn't being called clean up the stuff ourselves
	//muntrace();
	//chdir("/usr/gp2x");
	//execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);

	return 0;

}
