#ifndef MAIN_H
#define MAIN_H

#include "CWorldParts.h"


const int MaxLevelPacks=200,
		  MaxMusicFiles=26,
		  NrOfSounds=10,
		  SND_Destroy = 0,
		  SND_NoMoves = 1,
		  SND_Win = 2,
		  SND_WinExit = 3,
		  SND_DirectionMove = 4,
		  SND_GameOver = 5,
		  SND_Score = 6,
		  SND_LevelEditorSelect = 7,
		  SND_Select = 8,
		  SND_Error = 9,
		  MaxSkins=20,
		  FixedFPS=30;

const SDL_Rect DestRectsArrows[4] = {{122,224,80,80}, {208,298,80,80},{122,370,80,80},{33,298,80,80}};


enum GameStates {GSNone,GSGameOver,GSTitleScreen,GSLevelpackDone,GSCredits,GSIntro,GSQuit,GSGame,GSStageClear,GSStageSelect,GSLevelEditor,GSLevelEditorMenu};
enum Movements {MNone=4,MDown=2,MUp=0,MLeft=3,MRight=1};

struct SPoint{
    int X;
    int Y;
};

SDL_Surface *IMGBackgroundLevelEditor=NULL,*IMGBackground=NULL,*IMGBlocks=NULL,*IMGFloor = NULL,*IMGLevelDone=NULL, *IMGArrows1=NULL, *IMGArrows2=NULL,*IMGGameOver=NULL,*IMGLevelpackDone=NULL,*IMGTitleScreen=NULL,*IMGGrid=NULL;
SDL_Surface* SDLScreen,*Buffer;
TTF_Font* font,*BigFont;

SDL_Color TextColor;


Movements Movement = MNone;
CWorldParts* WorldParts;
GameStates GameState = GSTitleScreen;
GameStates PreviousGameState = GSTitleScreen;
int MaxMoves=0,Score=0,Retries=5,MusicCount=0,SelectedMusic=0,InstalledLevelPacksCount=0,SelectedLevelPack=0,InstalledSkinsCount=0,SelectedSkin=-1,Grid=1;
bool GlobalSoundEnabled = true;
int Volume = 128;
char InstalledLevelPacks[MaxLevelPacks][FILENAME_MAX];
Mix_Music *Music[MaxMusicFiles];
Mix_Chunk *Sounds[NrOfSounds];
char StartPath[PATH_MAX];
char InstalledSkins[MaxSkins][FILENAME_MAX];
char SkinName[FILENAME_MAX];
FPSmanager Fpsman;

#endif
